#define AppCreator 'pole'
#define OptionsMenuAbout 1000
#define AboutAlert 1000
#define InputAlert 1100
#define MainForm 1000
#define FieldA 1001
#define FieldB 1010
#define FieldE 1020
#define FieldN 1030
// #define LabelPole 2000
// #define LabelTm 2010
// #define LabelE 2020
// #define LabelN 2030
#define BtnP2T 4000
#define BtnT2P 4010

int MathLibRef = -1;

static void p2t (FormPtr frmP)
{
Handle eh1, eh2, h, he, hn, ha, hp, hq, hr, hs, ht, hu, hv, hw;
// UInt32 x, y;
UInt32 ax, ay, ax2, ay2, ax3, ay3;
UInt wi;
long x, y, x1, x2, x3, y1, y2, y3, le, la;
CharPtr es1, es2, str, str2, stre, strn, errstr, areaCode, pp, qq, r, s, t, u, v, w;
FieldPtr flda, fldb, flde, fldn;
Char tchar;

wi = 0;

flda = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,FieldA));
fldb = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,FieldB));

es1 = FldGetTextPtr (flda);
es2 = FldGetTextPtr (fldb);
eh1 = MemHandleNew (20);
eh2 = MemHandleNew (20);
str = MemHandleLock (eh1);
str2 = MemHandleLock (eh2);
StrToLower (str, es1);
StrToLower (str2, es2);

ha = MemHandleNew (2);
hp = MemHandleNew (3);
hq = MemHandleNew (3);

areaCode = MemHandleLock (ha);
pp = MemHandleLock (hp);
qq = MemHandleLock (hq);

StrNCopy(areaCode, str, 1);
areaCode[1] = '\0';
StrNCopy(pp, str+1, 2);
pp[2] = '\0';
StrNCopy(qq, str+3, 2);
qq[2] = '\0';

if ((pp[0] < '0') || (pp[0] > '9')) {
    wi = 8;
}
if ((qq[0] < '0') || (qq[0] > '9')) {
    wi = 8;
}

if ((pp[1] < '0') || (pp[1] > '9')) {
    wi = 8;
}
if ((qq[1] < '0') || (qq[1] > '9')) {
    wi = 8;
}

ax = StrAToI (pp);
ay = StrAToI (qq);

hr = MemHandleNew (2);
hs = MemHandleNew (2);
ht = MemHandleNew (2);
hu = MemHandleNew (2);
hv = MemHandleNew (2);
hw = MemHandleNew (2);

r = MemHandleLock (hr);
s = MemHandleLock (hs);
t = MemHandleLock (ht);
u = MemHandleLock (hu);
v = MemHandleLock (hv);
w = MemHandleLock (hw);

StrNCopy (r, str2, 1);
StrNCopy (s, str2+1, 1);
StrNCopy (t, str2+2, 1);
StrNCopy (u, str2+3, 1);
if ((t[0] < '0') || (t[0] > '9')) {
    wi = 8;
}
if ((u[0] < '0') || (u[0] > '9')) {
    wi = 8;
}
if (StrLen (str2) == 6) {
    StrNCopy (v, str2+4, 1);
    StrNCopy (w, str2+5, 1);
    v[1] = '\0';
    w[1] = '\0';
    if ((v[0] < '0') || (v[0] > '9')) {
        wi = 8;
    }
    if ((w[0] < '0') || (w[0] > '9')) {
        wi = 8;
    }
    ax3 = StrAToI (v);
    ay3 = StrAToI (w);
    if ((ax3 > 9) || (ay3 > 9)) {
        wi = 7;
    }
}
r[1] = '\0';
s[1] = '\0';
t[1] = '\0';
u[1] = '\0';

ax2 = StrAToI (t);
ay2 = StrAToI (u);

if ((StrLen(str) != 5) || 
     !(StrLen (str2) == 4 || StrLen(str2) == 6)) {
    wi = 1;
} else if (areaCode[0] < 'a' || areaCode[0] > 'z') {
    wi = 2;
} else if (r[0] < 'a' || r[0] > 'h') {
    wi = 6;
} else if (s[0] < 'a' || s[0] > 'e') {
    wi = 3;
} else if ((ax > 99) || (ay > 99)) {
    wi = 4;
} else if ((ax2 > 9) || (ay2 > 9)) {
    wi = 5;
}

tchar = areaCode[0];

switch (tchar) {
   case 'a':
	x = 170000;
	y = 2500000;
	break;
   case 'b':
	x = 250000;
	y = 2750000;
	break;
   case 'c':
	x = 330000;
	y = 2750000;
	break;
   case 'd':
	x = 170000;
	y = 2700000;
	break;
   case 'e':
	x = 250000;
	y = 2700000;
	break;
   case 'f':
	x = 330000;
	y = 2700000;
	break;
   case 'g':
	x = 170000;
	y = 2650000;
	break;
   case 'h':
	x = 250000;
	y = 2650000;
	break;
   case 'j':
	x = 90000;
	y = 2600000;
	break;
   case 'k':
	x =170000;
	y = 2600000;
	break;
   case 'l':
	x = 250000;
	y = 2600000;
	break;
   case 'm':
	x = 90000;
	y = 2550000;
	break;
   case 'n':
	x = 170000;
	y = 2550000;
	break;
   case 'o':
	x = 250000;
	y = 2550000;
	break;
   case 'p':
	x = 90000;
	y = 2500000;
	break;
   case 'q':
	x = 170000;
	y = 2500000;
	break;
   case 'r':
	x = 250000;
	y = 2500000;
	break;
   case 't':
	x = 170000;
	y = 2450000;
	break;
   case 'u':
	x = 250000;
	y = 2450000;
	break;
   case 'v':
	x = 170000;
	y = 2400000;
	break;
   case 'w':
	x = 250000;
	y = 2400000;
          break;
   case 'x':
	x = 251000;
	y = 2614000;
          break;
   case 'y':
	x = 251000;
	y = 2564000;
          break;
   case 'z':
	x = 552700;
	y = 2675800;
          break;
}

if (wi > 0) {
    FrmAlert(InputAlert);
//    h = MemHandleNew (20);
//    errstr = MemHandleLock (h);
//    StrPrintF (errstr, "%i", wi);
//    WinDrawChars(errstr,StrLen(errstr),10,20);
//    MemHandleUnlock (h);
//    MemHandleFree (h);
} else {
    x = x + ax*800 + ((UInt32)(r[0] - 'a'))*100 + ax2*10;
    y = y + ay*500 + ((UInt32)(s[0] - 'a'))*100 + ay2*10;

    if (StrLen(str2) == 6) {
	x = x + ax3;
	y = y + ay3;
    }

    flde = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,FieldE));
    fldn = FrmGetObjectPtr (frmP, FrmGetObjectIndex(frmP,FieldN));
    he = MemHandleNew(16);
    hn = MemHandleNew(16);
    stre = MemHandleLock (he);
    strn = MemHandleLock (hn);
    StrIToA (stre, x);
    StrIToA (strn, y);
    FldSetTextHandle (flde, he);
    FldSetTextHandle (fldn, hn);
    MemHandleUnlock (he);
    MemHandleUnlock (hn);
//    MemHandleFree (he);
//    MemHandleFree (hn);
    FldDrawField (flde);
    FldDrawField (fldn);
}

MemHandleUnlock (eh1);
MemHandleUnlock (eh2);
MemHandleFree (eh1);
MemHandleFree (eh2);

MemHandleUnlock (ha);
MemHandleUnlock (hp);
MemHandleUnlock (hq);

MemHandleFree (ha);
MemHandleFree (hp);
MemHandleFree (hq);

MemHandleUnlock (hr);
MemHandleUnlock (hs);
MemHandleUnlock (ht);
MemHandleUnlock (hu);
MemHandleUnlock (hv);
MemHandleUnlock (hw);

MemHandleFree (hr);
MemHandleFree (hs);
MemHandleFree (ht);
MemHandleFree (hu);
MemHandleFree (hv);
MemHandleFree (hw);

eh1 = MemHandleNew (20);
eh2 = MemHandleNew (20);
es1 = MemHandleLock (eh1);
es2 = MemHandleLock (eh2);
le = x-250000;
le = le/28.12;
le = le + 435600;
la = y/30.73;
x1 = le/3600;
x2 = (le%3600);
x2 = x2/60;
x3 = le%60;
y1 = la/3600;
y2 = (la%3600);
y2 = y2/60;
y3 = la%60;
    h = MemHandleNew (40);
    errstr = MemHandleLock (h);
    StrPrintF (errstr, "%lid%02li'%02li\"E     %lid%02li'%02li\"N", x1, x2, x3, y1, y2, y3);
    WinDrawChars(errstr,StrLen(errstr),20,100);
    MemHandleUnlock (h);
    MemHandleFree (h);
MemHandleUnlock (eh1);
MemHandleUnlock (eh2);
MemHandleFree (eh1);
MemHandleFree (eh2);
}

static void t2p (FormPtr frmP)
{
    FrmAlert(AboutAlert);
}

static void mainFormInit(FormPtr frmP)
{

}

static Boolean doMenu(FormPtr frmP, Word command)
{
Boolean handled = false;
switch (command) {
    case OptionsMenuAbout :
        FrmAlert(AboutAlert);
        handled = true;
        break;
    }
    return handled;
}

Boolean mainFormEventHandler(EventPtr eventP) {
Boolean handled = false;
FormPtr frmP= FrmGetActiveForm();
    if (eventP->eType == frmOpenEvent) {
        FrmDrawForm(frmP);
        handled = true;
    } else if (eventP->eType == menuEvent) {
        handled = doMenu(frmP, eventP->data.menu.itemID); 
    } else if (eventP->eType == ctlSelectEvent) {
        switch (eventP->data.ctlSelect.controlID) {
            case BtnP2T:
            p2t(frmP);
            handled = true;
            break;
            case BtnT2P:
            t2p(frmP);
            handled = true;
            break;       
        }
    }   // if
return handled;
}

void startApp() {

}

void stopApp() {

}

void initMath() {
Err err;
err = SysLibFind("MathLib", &MathLibRef);
if (err != 0) { // library not loaded already
    err = SysLibLoad('libr', 'MthL', &MathLibRef);
    if (err == 0)
        err = MathLibOpen (MathLibRef, 1);
    }
}

void termMath() {
if (MathLibRef != -1) {
    Err err;
    UInt usecount;
    err = MathLibClose (MathLibRef, &usecount);
    if (usecount == 0)
        SysLibRemove (MathLibRef);
    }
}

Boolean appHandleEvent(EventPtr event) {
FormPtr frm;
Int             formId;
Boolean handled = false;
if (event->eType == frmLoadEvent) {
    formId = event->data.frmLoad.formID;
    frm = FrmInitForm(formId);
    FrmSetActiveForm(frm);
    if (formId == MainForm)
        FrmSetEventHandler (frm, mainFormEventHandler);
    handled = true;
}       
return handled;
}

DWord PilotMain(Word cmd, char *cmdPBP, Word launchFlags)
{
EventType event;
Word error;
if (cmd == sysAppLaunchCmdNormalLaunch) {
    initMath();
    startApp();
    FrmGotoForm(MainForm);
    do {
        EvtGetEvent(&event, evtWaitForever);
        if (!SysHandleEvent (&event))
        if (!MenuHandleEvent (0, &event, &error))
        if (!appHandleEvent (&event))
                FrmDispatchEvent (&event);
    } while (event.eType != appStopEvent);
    stopApp();
    termMath();
    FrmCloseAllForms();
}
return 0;
}